//+------------------------------------------------------------------+
//|                                  Simpel_System                   |
//|                            Copyright  2008, Heino               |
//|                                 kuc2n@yahoo.de                   |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, \"Heino\" "
#property link      "kuc2n@yahoo.de"
//----
#define Buytyp OP_BUY
#define Selltyp OP_SELL


//----Intern
string scriptname="Simpel_System";


//----Extern 
extern string Moving_Average_Setting_____ = "____________________________________________";
extern bool   MovingAverage = true;
extern int    MA1           = 5,
              MA2           = 8,
              MA1_price     = 0,
              MA2_price     = 1,
              MA1_method    = 1,
              MA2_method    = 1,
              MA_Abweichung = 1,
              MA_Shift      = 1;
extern bool   MA_Zeichnen   = true;



extern string DinapoliStoch_Setting______ = "____________________________________________";
extern bool   DinapoliStoch           = true;
extern int    DinapoliStochFastK      = 8,
              DinapoliStochSlowK      = 3,
              DinapoliStochSlowD      = 3;
extern double DinapoliStochAbweichung = 1.0;
extern int    DinapoliStochShift      = 1;



extern string MomentumVT_Setting_________ = "____________________________________________";
extern bool   MomentumVT    = true;
extern int    MomentumVTP   = 10;
extern double MomentumLevel = 0.0005;
extern int    MomentumShift = 1;           

extern string QQE_Setting______________ = "____________________________________________";
extern bool   QQE           = true;
extern int    QQEFaktor     = 1;
extern double QQEAbweichung = 1.0;
extern int    QQEShift      = 1;


extern string ADX_Setting______________ = "____________________________________________";
extern bool   ADX           = false;
extern int    ADXLevel      = 30;   
   
              

extern string Tradingtime_Setting_______ = "____________________________________________";
extern string Von    = "00:00"; 
extern string Bis    = "23:59";

     


              
extern string Order_Setting__________ = "____________________________________________";
extern double Lots            = 0.1;
extern double TakeProfit      = 140;
extern double StopLoss        = 40;
extern double TrailingStop    = 30;
extern int    Sicherheitsstop = 0;
extern bool   BuyErlaubt      = true;
extern bool   SellErlaubt     = true;
extern bool   MoneyManagement = true;
extern double MaximumRisk     = 0.02;












extern string _._._Kommentare_Management._._ = "._._._._Kommentare_Management._._._.";
extern bool Kommentare_Kurse = true;
bool Kommentare=false;
extern bool Kommentare_Striche = true;
extern bool Kommentare_Profit = true;



          
              
extern string __________Options5__________="______________Options5___________";
extern color Color_Trend_Buy            = MediumSpringGreen,
             Color_Trend_Sell           = Coral,
             Color_Trend_Neutral        = Yellow;
             
             
int Tag = 0,
    Slippage  =   3,
    OpenOrdersGesamt,
    CloseOrdersGesamt,
    Takeprofitverschieben=0,
    MagicNummer;
double OpenOrdersProfitGesamt,CloseOrdersProfitGesamt;
double Open_Orders_[1][14];
double Close_Orders_[1][15];
double    stoplevel;
int WievielMinutenGueltig  = 100000,       
    PauseAfterError=1000, //1000 milisekunden gleich 1 sekunde
    Versuche = 7;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+



//----Bibliotheken mit Funktionen fr bessere Fehlermeldungen Ausdruck
#include <stderror.mqh>
#include <stdlib.mqh>


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
  MagicNummer = 1+WindowHandle(Symbol(),0);
  return(0);
  }
  


//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }



//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {



int err = GetLastError();if(err>0)Print("Start Error  #",err);
//----Stoploss und Takeprofit berprfen ob nicht zu klein
double stoplevel = MarketInfo(Symbol(), MODE_STOPLEVEL);
//double mindeststopkurs = (stoplevel+MarketInfo(Symbol(), MODE_SPREAD));
double mindeststopkurs = (stoplevel);
//Print("mindeststopkurs ",mindeststopkurs);
if(StopLoss < mindeststopkurs)
{ //Stop zu klein
 StopLoss=stoplevel+MarketInfo( Symbol(), MODE_SPREAD);
 Print("StopLoss zu klein auf ",StopLoss," gendert");
}

err = GetLastError();if(err>0)Print("HochTief 1.2 Error  #",err);

if(TakeProfit <= MarketInfo(Symbol(), MODE_SPREAD))
{ //Takeprofit zu klein
 TakeProfit = MarketInfo(Symbol(), MODE_SPREAD)+1;
 Print("TakeProfit zu klein auf ",TakeProfit," gendert");
}
if(TrailingStop>0&&TrailingStop<mindeststopkurs)
{//TrailingStop zu klein
 TrailingStop=mindeststopkurs;
 Print("TrailingStop zu klein auf ",TrailingStop," gendert");
}


      
static int Durchlauf, Balken;
err = GetLastError();if(err>0)Print("nach inlcude 1 Error  #",err);

  

//----
if(TrailingStop > 0) TrailingPositions(TrailingStop);






//+------------------------------------------------------------------+
//|Moving Average zeichnen                                           |
//+------------------------------------------------------------------+
if(MA_Zeichnen){
if(Durchlauf==0) int lauf=Bars-2; else lauf=1;   
for(int pos=0; pos<lauf && 1; pos++)
{  
HideTestIndicators(true);
double ma1_1=iMA(Symbol(), 0, MA1, 0, MA1_method, MA1_price, 0+pos);
double ma1_2=iMA(Symbol(), 0, MA1, 0, MA1_method, MA1_price, 0+pos+1);
HideTestIndicators(false);

  string ma="ma1"+TimeToStr(Time[pos]);
  if(ObjectFind(ma) >= 0) ObjectDelete(ma);
  if(!ObjectCreate(ma,OBJ_TREND,0,Time[pos],ma1_1,Time[pos+1],ma1_2 ))Print("Cant create objektzeichnen! 0 code #", GetLastError());
  if(!ObjectSet(ma, OBJPROP_RAY, false))Print("Cant set1 ray objektzeichnen! 0  code #", GetLastError());
  if(!ObjectSet(ma, OBJPROP_WIDTH, 1)) Print("Cant set3 width objektzeichnen! 0  code #", GetLastError());
  if(!ObjectSet(ma, OBJPROP_STYLE, 0)) Print("Cant set3 width objektzeichnen! 0  code #", GetLastError());
  if(!ObjectSet(ma, OBJPROP_COLOR, Yellow))Print("Cant set2 color objektzeichnen! 0  code #", GetLastError()); 

HideTestIndicators(true);  
ma1_1=iMA(Symbol(), 0, MA2, 0, MA2_method, MA2_price, 0+pos);
ma1_2=iMA(Symbol(), 0, MA2, 0, MA2_method, MA2_price, 0+pos+1);
HideTestIndicators(false);
 
  ma="ma2"+TimeToStr(Time[pos]);
  if(ObjectFind(ma) >= 0) ObjectDelete(ma);
  if(!ObjectCreate(ma,OBJ_TREND,0,Time[pos],ma1_1,Time[pos+1],ma1_2 ))Print("Cant create objektzeichnen! 0 code #", GetLastError());
  if(!ObjectSet(ma, OBJPROP_RAY, false))Print("Cant set1 ray objektzeichnen! 0  code #", GetLastError());
  if(!ObjectSet(ma, OBJPROP_WIDTH, 1)) Print("Cant set3 width objektzeichnen! 0  code #", GetLastError());
  if(!ObjectSet(ma, OBJPROP_STYLE, 0)) Print("Cant set3 width objektzeichnen! 0  code #", GetLastError());
  if(!ObjectSet(ma, OBJPROP_COLOR, Red))Print("Cant set2 color objektzeichnen! 0  code #", GetLastError());  
}
}
HideTestIndicators(true);
//----Moving Average
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double ima1 = iMA(Symbol(),0,MA1,0,MA1_method,MA1_price,MA_Shift);
double ima2 = iMA(Symbol(),0,MA2,0,MA2_method,MA2_price,MA_Shift);
if(ima1>ima2 && MathAbs(ima1-ima2)>=Point*MA_Abweichung)int trend=1;
else if(ima1<ima2 && MathAbs(ima1-ima2)>=Point*MA_Abweichung)    trend=2;
if(MovingAverage==false)trend=0;
//----Dinapoli
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double dinapoli1 = iCustom(NULL,0,"Dinapoli stoch",DinapoliStochFastK,DinapoliStochSlowK,DinapoliStochSlowD,0,DinapoliStochShift);
double dinapoli2 = iCustom(NULL,0,"Dinapoli stoch",DinapoliStochFastK,DinapoliStochSlowK,DinapoliStochSlowD,1,DinapoliStochShift);
if(dinapoli1>dinapoli2 && MathAbs(dinapoli1-dinapoli2)>=DinapoliStochAbweichung)  int dtrend=1;
else if(dinapoli1<dinapoli2 && MathAbs(dinapoli1-dinapoli2)>=DinapoliStochAbweichung) dtrend=2;
//----Momentum
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double mom = iCustom(NULL,0,"MomentumVT",MomentumVTP,0,MomentumShift);
if(mom>=MomentumLevel)  int mtrend=1;
else if(mom<-MomentumLevel) mtrend=2;
if(MovingAverage==false)trend=mtrend;
//----QQE
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double qqe1 = iCustom(NULL,0,"QQE[1]",QQEFaktor,0,QQEShift);
double qqe2 = iCustom(NULL,0,"QQE[1]",QQEFaktor,1,QQEShift);
if(qqe1>qqe2 && MathAbs(qqe1-qqe2)>=Point*QQEAbweichung)  int qtrend=1;
else if(qqe1<qqe2 && MathAbs(qqe1-qqe2)>=Point*QQEAbweichung) qtrend=2;
if(MovingAverage==false)trend=qtrend;
HideTestIndicators(false);
//+------------------------------------------------------------------+
//| Signale steuern                                                  |
//+------------------------------------------------------------------+
if(DinapoliStoch && dtrend!=trend)trend=0;
if(MomentumVT && mtrend!=trend)   trend=0;
if(QQE && qtrend!=trend)          trend=0;
Trend(trend);




 static int m,d;
 if(d!=TimeDay(Time[0])){d=TimeDay(Time[0]);m=0;}
 //Comment("mom  ",mom,"  dinapoli1 ",dinapoli1,"   dinapoli1 ",dinapoli2,"  DABW  ",MathAbs(dinapoli1-dinapoli2)," qqe1 ",qqe1,"   qqe2 ",qqe2,"  QEAW ",MathAbs(qqe1-qqe2));
 

 int von1 = StrToTime(TimeToStr(Time[0],TIME_DATE)+" "+Von);
 int bis1 = StrToTime(TimeToStr(Time[0],TIME_DATE)+" "+Bis);
//Comment("Zeit: ",TimeToStr(TimeCurrent()),"  von: ",TimeToStr(von1),"  bis: ",TimeToStr(bis1),"  ",TimeToStr(ende1));
//+------------------------------------------------------------------+
//| Handel                                                           |
//+------------------------------------------------------------------+ 
//----Erlaubnis: Handelszeit
if(TimeCurrent()>=von1 && TimeCurrent()<=bis1)
{

 
     /*
  LetzteOrderClose(MagicNummer)&&
     
  LetzteOrderProfit(Buytyp, MagicNummer))
  OpenOrderAnzahl(MagicNummer2)<=0
  LetzteOrderTyp(Buytyp,MagicNummer)==Buytyp
  CheckForOpen(Buytyp, LotsOptimized(), TakeProfit, StopLoss, scriptname, MagicNummer);
  LetzteOrderOpen(MagicNummer)>0
  OpenOrderAnzahl(MagicNummer2)>0  
  OpenOrderAnzahl(MagicNummer)<=0 
  CalculateCurrentOrder(Buytyp)!=Buytyp)
  if(Taggewechselt==1)
  CheckForClose(Selltyp, MagicNummer);
  CheckForOpen(Buytyp, AktuelleLots(MagicNummer2), TakeProfit, StopLoss, scriptname, MagicNummer);
  */

  
 /*
 if(tag-Tag-1>=0){
//PivotPointR1[1],PivotPointR2[1],PivotPointR3[1],PivotPointS1[1],PivotPointS2[1],PivotPointS3[1],
 
 if(Bid<=PivotPointR1[tag-Tag-1]+Point*2 && Bid>=PivotPointR1[tag-Tag-1]-Point*2 && OpenOrderAnzahl(1)<=0 && trend==2)
 CheckForOpen(Selltyp, LotsOptimized(), TakeProfit, StopLoss, scriptname, 1);
 if(Bid<=PivotPointR2[tag-Tag-1]+Point*2 && Bid>=PivotPointR2[tag-Tag-1]-Point*2 && OpenOrderAnzahl(2)<=0 && trend==2)
 CheckForOpen(Selltyp, LotsOptimized(), TakeProfit, StopLoss, scriptname, 2); 
 if(Bid<=PivotPointR3[tag-Tag-1]+Point*2 && Bid>=PivotPointR3[tag-Tag-1]-Point*2 && OpenOrderAnzahl(3)<=0 && trend==2)
 CheckForOpen(Selltyp, LotsOptimized(), TakeProfit, StopLoss, scriptname, 3); 
 
 if(Bid<=PivotPointS1[tag-Tag-1]+Point*2 && Bid>=PivotPointS1[tag-Tag-1]-Point*2 && OpenOrderAnzahl(4)<=0 && trend==1)
 CheckForOpen(Buytyp, LotsOptimized(), TakeProfit, StopLoss, scriptname, 4);
 if(Bid<=PivotPointS2[tag-Tag-1]+Point*2 && Bid>=PivotPointS2[tag-Tag-1]-Point*2 && OpenOrderAnzahl(5)<=0 && trend==1)
 CheckForOpen(Buytyp, LotsOptimized(), TakeProfit, StopLoss, scriptname, 5); 
 if(Bid<=PivotPointS3[tag-Tag-1]+Point*2 && Bid>=PivotPointS3[tag-Tag-1]-Point*2 && OpenOrderAnzahl(6)<=0 && trend==1)
 CheckForOpen(Buytyp, LotsOptimized(), TakeProfit, StopLoss, scriptname, 6); 

Comment("\n\n\n\nS1 ",PivotPointS1[tag-Tag-1],"  S2 ",PivotPointS2[tag-Tag-1],"  S3 ",PivotPointS3[tag-Tag-1],
"\nR1 ",PivotPointR1[tag-Tag-1],"  R2 ",PivotPointR2[tag-Tag-1],"  R3 ",PivotPointR3[tag-Tag-1]);
}
*/


static int b,s,m2,m3;
double val=iADX(NULL,0,14,PRICE_HIGH,MODE_MAIN,1);
if(val<=20 && iADX(NULL,0,14,PRICE_HIGH,MODE_MAIN,0)<=iADX(NULL,0,14,PRICE_HIGH,MODE_MAIN,1))
{
int tk=TakeProfit; int st=TakeProfit;
//TrailingPositions(10);
}
else  {tk=TakeProfit;st=StopLoss;}
if(ADX==false)val=1000000000;
/*
static int g;
double eval1=iEnvelopes(NULL, 0, 32,MODE_EMA,0,PRICE_CLOSE,0.05,MODE_UPPER,0);
double eval2=iEnvelopes(NULL, 0, 32,MODE_EMA,0,PRICE_CLOSE,0.05,MODE_LOWER,0);
double atr=iATR(NULL,0,12,0)>iATR(NULL,0,14,1);
*/
/*
if(
//mom > -0.0040 && mom < 0.0040 && 
//val>30
atr<0.0020
)
{
if(Bid>=eval1 && OpenOrderAnzahl(2)<=0)
{
//CheckForOpen(Buytyp, LotsOptimized(), tk, st, scriptname, 1);
CheckForOpen(Selltyp, LotsOptimized(), tk, st, scriptname, 2);
}
if(Bid<=eval2 && OpenOrderAnzahl(1)<=0)
{
//CheckForOpen(Selltyp, LotsOptimized(), tk, st, scriptname, 2);
CheckForOpen(Buytyp, LotsOptimized(), tk, st, scriptname, 1);
}
*/
/*
g=1;
if(
//High[0]>High[1] 
//&& Low[0]>=Low[1] 
//&& OpenOrderAnzahl(1)<=0
g!=1
)
CheckForOpen(Buytyp, LotsOptimized(), 15, 20, scriptname, 1);
if(
//Low[0]<Low[1] 
//&& High[0]<=High[1] 
//&& OpenOrderAnzahl(2)<=0
g!=1
)
CheckForOpen(Selltyp, LotsOptimized(), 15, 20, scriptname, 2);
if(LetzteOrderOpen(1)>0 && Bid<=LetzteOrderOpen(1))
CheckForOpen(Buytyp, LotsOptimized(), 15, 20, scriptname, 1);
if(LetzteOrderOpen(2)>0 && Bid>=LetzteOrderOpen(2))
CheckForOpen(Selltyp, LotsOptimized(), 15, 20, scriptname, 2);
*/
/*}
else if(
atr>0.002
)
{

if(Bid>=eval1 && OpenOrderAnzahl(3)<=0)
{
CheckForOpen(Buytyp, LotsOptimized(), tk, st, scriptname, 3);
//CheckForOpen(Selltyp, LotsOptimized(), tk, st, scriptname, 2);
}
if(Bid<=eval2 && OpenOrderAnzahl(4)<=0)
{
CheckForOpen(Selltyp, LotsOptimized(), tk, st, scriptname, 4);
//CheckForOpen(Buytyp, LotsOptimized(), tk, st, scriptname, 1);
}


}
*/





 if(true)
 {

if(OpenOrderAnzahl(MagicNummer)<=0)m=0;

 if(trend==1) //Buy
 {
 CheckForClose(Selltyp, MagicNummer);
  if(
     //(OpenOrderAnzahl(MagicNummer)<=0 && Bid+Point*30<=LetzteOrderClose(Buytyp,MagicNummer))
     //|| (OpenOrderAnzahl(MagicNummer)<=0 && Bid-Point*30>=LetzteOrderClose(Buytyp,MagicNummer) )
     //||  (OpenOrderAnzahl(MagicNummer)<=0 && b<=Time[0]-(Period()*60*3))
    // || 
     (OpenOrderAnzahl(MagicNummer)<=0 && m!=1)
     //&& Bid > ima2
     // && High[0]>High[1]
     //&& Bid > Open[0]
     //&& ima1 >= iMA(Symbol(),0,MA1,0,MA1_method,MA1_price,MA_Shift+1)
     //&& iMomentum(NULL,0,10,PRICE_CLOSE,0)>0
     && val>ADXLevel
    )
    double lots;
    if(LotsOptimized()<AktuelleLots3(Selltyp))lots=AktuelleLots3(Selltyp); else lots=LotsOptimized();
  if(CheckForOpen(Buytyp, lots, tk, st, scriptname, MagicNummer)==1){m=1;m2=0;b=Time[0];}
   
  
  
 }

 if(trend==2) //Sell
 {
 
  CheckForClose(Buytyp, MagicNummer);   
  if(
     //(OpenOrderAnzahl(MagicNummer)<=0 && Bid-Point*30>=LetzteOrderClose(Selltyp,MagicNummer))
     //|| (OpenOrderAnzahl(MagicNummer)<=0 && Bid+Point*30<=LetzteOrderClose(Selltyp,MagicNummer))
     //||  (OpenOrderAnzahl(MagicNummer)<=0 && s<=Time[0]-(Period()*60*3))
    // ||
      (OpenOrderAnzahl(MagicNummer)<=0 && m!=2)
     //&& Bid < ima2
     // && Low[0]<Low[1]
     //&& Bid <= Open[0]
    // && ima1 <= iMA(Symbol(),0,MA1,0,MA1_method,MA1_price,MA_Shift+1)
    // && iMomentum(NULL,0,10,PRICE_CLOSE,0)<0
     && val>ADXLevel
     )
    if(LotsOptimized()<AktuelleLots3(Buytyp))lots=AktuelleLots3(Buytyp); else lots=LotsOptimized();
    if(CheckForOpen(Selltyp, lots, tk, st, scriptname, MagicNummer)==1){m=2;m3=0;s=Time[0];}
   
 }

}



/*
//----Nachkaufen
if(trend==2 && m==2 && CalculateCurrentOrder(Selltyp) != Selltyp && m2!=1 && LetzteOrderProfit(Selltyp, MagicNummer)<0)
if(CheckForOpen(Selltyp, LotsOptimized(), st, st, scriptname, MagicNummer)==1)m2=1;
//----Nachkaufen
if(trend==1 && m==1 && CalculateCurrentOrder(Buytyp) != Buytyp && m3!=1 && LetzteOrderProfit(Buytyp, MagicNummer)<0)
if(CheckForOpen(Buytyp, LotsOptimized(), st, st, scriptname, MagicNummer)==1)m3=1;
 */
/* 
if(CalculateCurrentOrder(Selltyp) == Selltyp && MathAbs(High[1]-High[0])>Point*3 && High[0]>High[1])
CheckForClose(Selltyp, MagicNummer);

if(CalculateCurrentOrder(Buytyp) == Buytyp && MathAbs(Low[1]-Low[0])>Point*3 && Low[0]<Low[1])
CheckForClose(Buytyp, MagicNummer);
*/

/*
 if(trend==1) //Buy
 {
 CheckForClose(Selltyp, MagicNummer);
  if(
     (OpenOrderAnzahl(MagicNummer)<=0 && Bid+Point*30<=LetzteOrderClose(Buytyp,MagicNummer))
     
    )
  if(CheckForOpen(Buytyp, LotsOptimized(), tk, st, scriptname, MagicNummer)==1){m=1;b=Time[0];}
   
  
  
 }

 if(trend==2) //Sell
 {
 
  CheckForClose(Buytyp, MagicNummer);   
  if(
     (OpenOrderAnzahl(MagicNummer)<=0 && Bid-Point*30>=LetzteOrderClose(Selltyp,MagicNummer))
     
     )
    if(CheckForOpen(Selltyp, LotsOptimized(), tk, st, scriptname, MagicNummer)==1){m=2;s=Time[0];}
   
 }
*/

 //----Signal neutral alles schlieen
 //if(v1==v2){CheckForClose(0);CheckForClose(1);}


}//----Erlaubnis: Handelszeit



//+------------------------------------------------------------------+
//| Profit anzeigen                                                  |
//+------------------------------------------------------------------+     
double Pipsprofit,Offeneprofit,Closeprofit;
//----Profite von den Orders sammeln
AktuelleOrderPips(MagicNummer,  Pipsprofit, Offeneprofit, Closeprofit);
//----Paar Infos
obj(1, "Offenne Positionen: ",OpenOrderAnzahl(MagicNummer), 0, 7, 15 );
obj(2, "Profit/Pip           =  ",Pipsprofit, 4, 22, 30 );
obj(3, "Profit               =  ",Offeneprofit, 2, 39, 47 );
obj(4, "Profit/Orders    =  ",Closeprofit, 2, 56, 65 );
obj(1, "Anzahl Open Orders: ",OrderAnzahlOpenGesamt2(), 0, 72, 80 );



//----Normale Order Sicherheitsstop
if(Sicherheitsstop>0)Stopsichern(MagicNummer, Sicherheitsstop);

err = GetLastError();if(err>0)Print("vor profitanzeige aufruf Error  #",err);
if(Kommentare_Profit == true) OrdersGesamt(Symbol(), OpenOrdersGesamt, CloseOrdersGesamt, OpenOrdersProfitGesamt, CloseOrdersProfitGesamt);
err = GetLastError();if(err>0)Print("nach profitanzeige aufruf Error  #",err);



//----
if(Durchlauf==0) Durchlauf = 1;
//----



return(0);
}
//+-------------------------------------------------------------------+



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Trend(int trend)
{
if(trend==1)
{
string str="BUY"; color col=Lime;
}
if(trend==2)
{
str="SELL"; col=Red;
}
else {str="";string t1="TheTrend";
  if(ObjectFind(t1) >= 0) ObjectDelete(t1);}

if(trend==1 || trend==2)
 {
  t1="TheTrend";
  if(ObjectFind(t1) >= 0) ObjectDelete(t1);
  if(!ObjectCreate(t1,OBJ_LABEL,0,0,0))Print("error: cant create ",t1," ! 0   code #",GetLastError());
  if(!ObjectSet(t1,OBJPROP_XDISTANCE,4))Print("error: cant set xdistance ",t1," ! 0   code #",GetLastError());
  if(!ObjectSet(t1,OBJPROP_YDISTANCE,205))Print("error: cant set ydistance ",t1," ! 0   code #",GetLastError());
  if(!ObjectSet(t1,OBJPROP_WIDTH,1))Print("error: cant set width ",t1," ! 0   code #",GetLastError());
  if(!ObjectSetText(t1, "Trend: "+str, 15, "Arial Black", col))Print("error: cant set ObjectSetText ",t1," ! 0   code #",GetLastError());  
 }
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double AktuelleOrderOpen(int nr)
{
for(int cnt=0; cnt <= OrdersTotal(); cnt++)
 {
   if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)==true)
   {  
   if(StringSubstr(OrderComment(),0,4) == StringSubstr(scriptname,0,4) && OrderMagicNumber()==nr)
    {
    return(OrderOpenPrice());
    }
   }
 }
 return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double AktuelleLots(int typ, int nr)
{
double lots=0;
for(int cnt=0; cnt <= OrdersTotal(); cnt++)
 {
   if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)==true)
   {  
   if(StringSubstr(OrderComment(),0,4) == StringSubstr(scriptname,0,4) && OrderMagicNumber()==nr && OrderType()==typ)
    {
    lots+=OrderLots();
    }
   }
 }
 if(lots<=0)lots=LotsOptimized();
 return(lots);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int LetzteOrderTyp2(int nr)
{
for(int cnt=OrdersHistoryTotal(); cnt >= 0; cnt--)
 {
   if(OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY)==true)
   {  
   if(StringSubstr(OrderComment(),0,4) == StringSubstr(scriptname,0,4) && OrderMagicNumber()==nr)
    {
     return(OrderType());
    }
   }
 }
 return(10);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int LetzteOrderTyp(int typ, int nr)
{
for(int cnt=OrdersHistoryTotal(); cnt >= 0; cnt--)
 {
   if(OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY)==true)
   {  
   if(StringSubstr(OrderComment(),0,4) == StringSubstr(scriptname,0,4) && OrderMagicNumber()==nr)
    {
    if(typ==OrderType()) return(OrderType());
    }
   }
 }
 return(10);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double LetzteOrderOpen(int nr)
{
for(int cnt=OrdersHistoryTotal(); cnt >= 0; cnt--)
 {
   if(OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY)==true)
   {  
   if(StringSubstr(OrderComment(),0,4) == StringSubstr(scriptname,0,4) && OrderMagicNumber()==nr)
    {
    return(OrderOpenPrice());
    }
   }
 }
 return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double LetzteOrderClose(int typ, int nr)
{
for(int cnt=OrdersHistoryTotal(); cnt >= 0; cnt--)
 {
   if(OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY)==true)
   {  
   if(StringSubstr(OrderComment(),0,4) == StringSubstr(scriptname,0,4) && OrderMagicNumber()==nr && OrderType()==typ)
    {
    return(OrderClosePrice());
    }
   }
 }
 return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int LetzteOrderOpenTime(int typ, int nr)
{
for(int cnt=OrdersHistoryTotal(); cnt >= 0; cnt--)
 {
   if(OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY)==true)
   {  
   if(StringSubstr(OrderComment(),0,4) == StringSubstr(scriptname,0,4) && OrderMagicNumber()==nr)
    {
    if(typ==OrderType()) return(OrderOpenTime());
    }
   }
 }
 return(-1);
}



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double LetzteOrderProfit(int typ, int nr)
{
for(int cnt=OrdersHistoryTotal(); cnt >= 0; cnt--)
 {
   if(OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY)==true)
   {  
   if(StringSubstr(OrderComment(),0,4) == StringSubstr(scriptname,0,4) && OrderMagicNumber()==nr)
    {
    if(typ==OrderType()) return(OrderProfit());
    }
   }
 }
 return(-1);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double VorLetzteOrderProfit(int typ, int nr, int pos)
{
int merk=0;
for(int cnt=OrdersHistoryTotal(); cnt >= 0; cnt--)
 {
   if(OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY)==true)
   {  
   if(StringSubstr(OrderComment(),0,4) == StringSubstr(scriptname,0,4) && OrderMagicNumber()==nr && typ==OrderType())
    {
    if(merk==pos)return(OrderProfit()); else merk++;
    }
   }
 }
 return(-1);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void obj(int i, string str, double anz, int di, int y, int y2)
{y=y+70;y2=y2+70;
  string t1="obj"+i;//stern
  if(ObjectFind(t1) >= 0) ObjectDelete(t1);
  if(!ObjectCreate(t1,OBJ_LABEL,0,0,0))Print("error: cant create ",t1," ! 0   code #",GetLastError());
  if(!ObjectSet(t1,OBJPROP_XDISTANCE,4))Print("error: cant set xdistance ",t1," ! 0   code #",GetLastError());
  if(!ObjectSet(t1,OBJPROP_YDISTANCE,y))Print("error: cant set ydistance ",t1," ! 0   code #",GetLastError());
  if(!ObjectSet(t1,OBJPROP_WIDTH,1))Print("error: cant set width ",t1," ! 0   code #",GetLastError());
  ObjectSetText(t1, CharToStr(167), 22, "Wingdings", White);  
  t1="obj_"+i;
  if(ObjectFind(t1) >= 0) ObjectDelete(t1);
  if(!ObjectCreate(t1,OBJ_LABEL,0,0,0))Print("error: cant create ",t1," ! ",scriptname,"   code #",GetLastError());
  if(!ObjectSet(t1,OBJPROP_XDISTANCE,21))Print("error: cant set xdistance ",t1," ! ",scriptname,"   code #",GetLastError());
  if(!ObjectSet(t1,OBJPROP_YDISTANCE,y2))Print("error: cant set ydistance ",t1," ! ",scriptname,"   code #",GetLastError());
  if(!ObjectSet(t1,OBJPROP_WIDTH,1))Print("error: cant set width ",t1," ! ",scriptname,"   code #",GetLastError());
  if(anz>0)color col=Lime; else if(anz<0) col=Red; else if(anz==0) col=WhiteSmoke;
  if(di==0) col=WhiteSmoke;
  ObjectSetText(t1, str+" "+DoubleToStr(anz,di), 10, "Arial", col);  

//----
return(0);
}






//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double AktuelleLots2(int nr)
{
double lots=0;
for(int cnt=0; cnt <= OrdersTotal(); cnt++)
 {
  if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)==true)
   {  
   if(StringSubstr(OrderComment(),0,4) == StringSubstr(scriptname,0,4) && OrderMagicNumber()==nr)
    {
    //return(OrderLots());
    lots+=OrderLots();
    }
   }
 }
 if(lots<=0)lots=LotsOptimized();
 return(lots);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double AktuelleLots3(int typ)
{
double lots=0;
for(int cnt=0; cnt <= OrdersTotal(); cnt++)
 {
  if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)==true)
   {  
   if(StringSubstr(OrderComment(),0,4) == StringSubstr(scriptname,0,4) && OrderType()==typ)
    {
    lots+=OrderLots();
    }
   }
 }
 if(lots<=0)lots=LotsOptimized();
 return(lots);
}



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OrderAnzahlOpenGesamt2()
{
int anzahl=0;
for(int cnt=0; cnt <= OrdersTotal(); cnt++)
 {
  if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)==true)  
   {
     if(OrderSymbol() == Symbol() && StringSubstr(OrderComment(),0,4) == StringSubstr(scriptname,0,4) && OrderMagicNumber()==MagicNummer)
     if(OrderType() <= OP_SELL) anzahl++;
   }
 }
 return(anzahl);
}






//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int AktuelleOrderTyp(int nr)
{
for(int cnt=0; cnt <= OrdersTotal(); cnt++)
 {
  if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)==true)
   {  
   if(StringSubstr(OrderComment(),0,4) == StringSubstr(scriptname,0,4) && OrderMagicNumber()==nr)
    {
    return(OrderType());
    }
   }
 }
 return(10);
}




//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void objdel(string name)
{  
   string objektname4 = name;
   if(ObjectFind(objektname4) >= 0) ObjectDelete(objektname4);
return;   
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void AktuelleOrderPips(int nr, double &pips, double &openprofit, double &closeprofit)
{
double pip=0;
double openordersprofitgesamt=0;
for(int cnt=0; cnt <= OrdersTotal(); cnt++)
 {
  if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)==true)
   {  
   if(OrderSymbol() == Symbol() && StringSubstr(OrderComment(),0,4) == StringSubstr(scriptname,0,4) && OrderMagicNumber()==MagicNummer)
    {
    if(OrderType()==OP_BUY)pip+=Bid-OrderOpenPrice();
    else if(OrderType()==OP_SELL)pip+=OrderOpenPrice()-Ask;
    pips=pip;
    openordersprofitgesamt += OrderProfit();
    openprofit=openordersprofitgesamt;
    }
   }
 }
 double closeordersprofitgesamt=0;
 for(cnt=0; cnt<OrdersHistoryTotal(); cnt++)
   {
     if(OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY)==true)
      {
      if(OrderSymbol() == Symbol() && StringSubstr(OrderComment(),0,4) == StringSubstr(scriptname,0,4) && OrderMagicNumber()==MagicNummer)
      closeordersprofitgesamt += OrderProfit();
      closeprofit=closeordersprofitgesamt;
      }
   }
 return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Stopsichern2(int nr, int X_Pips)
{
int total=OrdersTotal();
 for(int cnt=0; cnt < total; cnt++)
 {
       if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)==true)
       {      
                 if(OrderSymbol()==Symbol() && StringSubstr(OrderComment(),0,4) == StringSubstr(scriptname,0,4) && OrderType()<=OP_SELL && OrderMagicNumber()==nr)
                 {
                           //----Normale Trallingstop
                            if(OrderType()==OP_BUY)   // long position is opened
                              {       
                                   //----normaler Trailingstop
                                   if(X_Pips>0)  
                                   {               
                                        if(Bid-OrderOpenPrice()>=Point*X_Pips) //Ist Gewinn grer gleich Trailingstop Distanz ?
                                        {
                                            if(OrderStopLoss()<OrderOpenPrice()+(Point*1)) //Ist Abstand von aktuelle Kurs bezglich des Stopkurses grer als Trallingstopabstand ?
                                             {
                                              OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+(Point*1),OrderTakeProfit(),0,Green);
                                              int err = GetLastError();
                                              if(err != 0)Print("Buyorder modify Trailingstop error #",err);
                                              return(0);
                                             }
                                        } 
                                   }
                              }
                              else if(OrderType()==OP_SELL)
                              {
                                   //----normaler Trailingstop
                                   if(X_Pips>0)  // go to short position
                                     {                   
                                           if(OrderOpenPrice()-Ask>=Point*X_Pips)
                                           {    
                                                if(OrderStopLoss()>OrderOpenPrice()-(Point*1)) //Ist Abstand von aktuelle Kurs bezglich des Stopkurses grer als Trallingstopabstand ?
                                                {
                                                 OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-(Point*1),OrderTakeProfit(),0,Red);
                                                 err = GetLastError();
                                                 if(err != 0)Print("Sellorder modify Trailingstop error #",err);
                                                 return(0);
                                                }
                                            }
                                     }
                               }
                  }
         }
    }   
}



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Stopsichern(int nr, int X_Pips)
{
int total=OrdersTotal();
 for(int cnt=0; cnt < total; cnt++)
 {
       if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)==true)
       {      
                 if(OrderSymbol()==Symbol() && StringSubstr(OrderComment(),0,4) == StringSubstr(scriptname,0,4) && OrderType()<=OP_SELL && OrderMagicNumber()==nr)
                 {
                           //----Normale Trallingstop
                            if(OrderType()==OP_BUY)   // long position is opened
                              {       
                                   //----normaler Trailingstop
                                   if(X_Pips>0)  
                                   {               
                                        if(Bid-OrderOpenPrice()>=Point*X_Pips) //Ist Gewinn grer gleich Trailingstop Distanz ?
                                        {
                                            if(OrderStopLoss()<OrderOpenPrice()+(Point*1)) //Ist Abstand von aktuelle Kurs bezglich des Stopkurses grer als Trallingstopabstand ?
                                             {
                                              OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+(Point*1),OrderTakeProfit(),0,Green);
                                              int err = GetLastError();
                                              if(err != 0)Print("Buyorder modify Trailingstop error #",err);
                                              return(0);
                                             }
                                        } 
                                   }
                              }
                              else if(OrderType()==OP_SELL)
                              {
                                   //----normaler Trailingstop
                                   if(X_Pips>0)  // go to short position
                                     {                   
                                           if(OrderOpenPrice()-Ask>=Point*X_Pips)
                                           {    
                                                if(OrderStopLoss()>OrderOpenPrice()-(Point*1)) //Ist Abstand von aktuelle Kurs bezglich des Stopkurses grer als Trallingstopabstand ?
                                                {
                                                 OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-(Point*1),OrderTakeProfit(),0,Red);
                                                 err = GetLastError();
                                                 if(err != 0)Print("Sellorder modify Trailingstop error #",err);
                                                 return(0);
                                                }
                                            }
                                     }
                               }
                  }
         }
    }   
}



//+------------------------------------------------------------------+
//| schliet alle                                                    |
//+------------------------------------------------------------------+
int CheckForClose2()
{ 
 //Bei Erfolg Rckgabe 1 sonst 0
 int err,funkt;
 int Gemacht=0;
 while(IsStopped()==false)
 {
 Gemacht++;
 if( OrderAnzahlOpenGesamt2() <= 0 ) break;  
   for(int i=0; i<OrdersTotal(); i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
      {
      if(StringSubstr(OrderComment(),0,4) == StringSubstr(scriptname,0,4) && OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNummer)
      {
      //---- check order type 
      if(OrderType()==OP_BUY)
        {
         if(OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,White)) {Print("BuyOrder #",OrderTicket()," Close"); funkt=1;} 
         else {RefreshRates(); err=GetLastError(); Print("Error(",err,") closing Buy position #",OrderTicket(),": ",ErrorDescription(err)); funkt=0;}
         break;
        }
      if(OrderType()==OP_SELL)
        {
         if(OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,White)) {Print("SellOrder #",OrderTicket()," Close"); funkt=1;}
         else {RefreshRates(); err=GetLastError(); Print("Error(",err,") closing Sell position #",OrderTicket(),": ",ErrorDescription(err));funkt=0;}
         break;
        }
      }
      }
     }
 Sleep(PauseAfterError); // 1000 millisekunden = 1 sekunde 
 if(Gemacht>Versuche)break;
 }//while           
return(OrdersTotal()); 
//---- Ende CheckForClose2
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double LotsOptimized()
  {
double lot;
if(MoneyManagement==true) {
//---- select lot size
  lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);
//---- return lot size
   if(lot<0.01) lot=0.01; 
 }//if mm == true
 else lot=Lots;
int err = GetLastError(); if(err>0)Print("bei LotsOptimized Error  #",err);        
return(lot);
//---- Ende LotsOptimized
}



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CalculateCurrentOrder(int nr)
{
for(int cnt=0; cnt <= OrdersTotal(); cnt++)
 {
   if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)==true)
   {  
   if(OrderSymbol()==Symbol()&& StringSubstr(OrderComment(),0,4) == StringSubstr(scriptname,0,4))
    {
    if(OrderType() == nr) 
    {    
     return(nr);
    }
   }
   }
 }
 return(5);
}


  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void TrailingPositions( int TrailingStop) {

 int total=OrdersTotal();
 for(int cnt=0; cnt < total; cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(StringSubstr(OrderComment(),0,4) == StringSubstr(scriptname,0,4)){
      if(OrderType()<=OP_SELL &&  OrderSymbol()==Symbol())  
        {
        if(OrderType()==OP_BUY)   // long position is opened
        {                         
          // check for trailing stop  bid kurs ist immer hher
          if(TrailingStop>0)  
          {                 
           if(Bid-OrderOpenPrice()>=Point*TrailingStop) //Ist Gewinn grer gleich Trailingstop Distanz ?
             {
            if(OrderStopLoss()<Bid-(Point*TrailingStop) || (OrderStopLoss()==0) ) //Ist der Stop kleiner als der Abstand von Trailingstop minus Bid Kurs
               {
                OrderModify(OrderTicket(),OrderOpenPrice(),Bid-(Point*TrailingStop),OrderTakeProfit()+(Point*Takeprofitverschieben),0,Green);
                int err = GetLastError();
                if(err != 0)Print("Buy Order modiy Trailingstop error #",err);
                return(0);
               }
             }
           }
       }
       else if(TrailingStop>0)  // go to short position
       {                   
            if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
              {
               if(OrderStopLoss()>(Ask+Point*TrailingStop) || (OrderStopLoss()==0) )
                 {
                  OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit()-(Point*Takeprofitverschieben),0,Red);
                  err = GetLastError();
                  if(err != 0)Print("Sell Order modify Trailingstop error #",err);
                  return(0);
                 }
              }
        }
    }
    }
    }
}  



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CheckForOpen(int signal, double vol, double tk, double st, string komtr, int nr)
{
 //Bei Erfolg Rckgabe 1 sonst 0
 int err = GetLastError(); if(err>0)Print("bei CheckForOpen Error  #",err);
 int right;
 int Gemacht=0;
 while(IsStopped()==false)
 {
 Gemacht++;
 if( CalculateCurrentOrder(nr) == nr ) break;
  //---- sell  
   if(signal==Selltyp)  
     {
      int ticket = OrderSend(Symbol(), OP_SELL, vol, Bid, Slippage, Bid+(st*Point), Bid-(tk*Point), komtr, nr, 0, Red);
      if (ticket>0) {Print("Order #",ticket," opend by Sell ",komtr," Signal");right=1;}
      else 
        {
         err=GetLastError();
         Print("Error(",err,") opening Sell ",komtr," position: ",err);
         right=0;
         RefreshRates();
        }         
      return(right);
     }     
   //---- buy 
   if(signal==Buytyp)  
     {
      ticket = OrderSend(Symbol(), OP_BUY, vol, Ask, Slippage, Ask-(st*Point), Ask+(tk*Point), komtr, nr, 0, Blue);
      if (ticket>0) {Print("Order #",ticket," opend Buy ",komtr," Signal");right=1;}
      else 
        {
         err=GetLastError();
         Print("Error(",err,") opening Buy ",komtr," position: ",err);
         right=0;
         RefreshRates();
        }        
      return(right);
     }
 Sleep(PauseAfterError); // 1000 millisekunden = 1 sekunde 
 if(Gemacht>Versuche)break;
 }//while
 err = GetLastError(); if(err>0)Print("bei CheckForOpen Error  #",err);
//----
return(0);
//---- Ende CheckForOpen
}

  

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OpenOrderAnzahl(int nr)
{
int anzahl=0;
for(int cnt=0; cnt < OrdersTotal(); cnt++)
 {
   if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)==true) 
   {
   if(OrderSymbol()==Symbol()&&OrderType() <= OP_SELL && StringSubstr(OrderComment(),0,4) == StringSubstr(scriptname,0,4) && OrderMagicNumber()==nr)
   {
     anzahl++;
   }
  }
 }
 return(anzahl); 
}



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//schliet bestimmte offenen vom EA 
int CheckForClose(int typ, int nr)
{
 int err,funkt;
 int Gemacht=0;
 while(IsStopped()==false)
 {
 Gemacht++;  
   if(OpenOrderAnzahl(nr) <= 0) break; //wenn alle zu sind abbrechen 
   for(int i=0; i<OrdersTotal(); i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
      {
      if(OrderSymbol()==Symbol() && StringSubstr(OrderComment(),0,4) == StringSubstr(scriptname,0,4) && OrderMagicNumber()==nr){ 
            
      if(OrderType()==typ)
        {
         if(OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,White)) {Print("BuyOrder ",OrderComment()," #",OrderTicket()," Close"); funkt=1;} 
         else {RefreshRates(); err=GetLastError(); Print("Error(",err,") closing Buy ",OrderComment()," position #",OrderTicket(),": ",ErrorDescription(err)); funkt=0;}
         break;
        }
      if(OrderType()==typ)
        {
         if(OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,White)) {Print("SellOrder ",OrderComment()," #",OrderTicket()," Close"); funkt=1;}
         else {RefreshRates(); err=GetLastError(); Print("Error(",err,") closing Sell ",OrderComment()," position #",OrderTicket(),": ",ErrorDescription(err));funkt=0;}
         break;
        }
        
      } 
     } 
     }   
  if(Gemacht>Versuche)break;
 }     
 
 if(Kommentare_Profit == true) OrdersGesamt(Symbol(), OpenOrdersGesamt, CloseOrdersGesamt, OpenOrdersProfitGesamt, CloseOrdersProfitGesamt);
     
return(funkt); 
//---- Ende CheckForClose
} 




void Anzeige_Infos(int barw, int baru, int TimeWiderstand, int TimeUnterstutzung, int dag, double Kauf, double Kauf2, double Verkauf, double Verkauf2,double high, double low, int LastTime, int ri)
{
if(Kommentare_Kurse == true){

 
//----buy1
  if(CalculateCurrentOrder(0)==0){
  if(ObjectFind("grr1rjk32gfl") >= 0)ObjectDelete("grr1rjk32gfl");if(ObjectFind("grr1rjk32gflefg") >= 0)ObjectDelete("grr1rjk32gflefg");
  string t1="grr1rgfl";
  if(ObjectFind(t1) >= 0) ObjectDelete(t1);
  if(!ObjectCreate(t1,OBJ_LABEL,0,0,0))Print("error: cant create ",t1," ! 0   code #",GetLastError());
  if(!ObjectSet(t1,OBJPROP_XDISTANCE,4))Print("error: cant set xdistance ",t1," ! 0   code #",GetLastError());
  if(!ObjectSet(t1,OBJPROP_YDISTANCE,45))Print("error: cant set ydistance ",t1," ! 0   code #",GetLastError());
  if(!ObjectSet(t1,OBJPROP_WIDTH,1))Print("error: cant set width ",t1," ! 0   code #",GetLastError());
  ObjectSetText(t1, "OPEN BUY @ : "+DoubleToStr(OpenOrderKurs(0) ,4), 11, "Arial Black", DodgerBlue);
  t1="grr1rgdgdffle";
  if(ObjectFind(t1) >= 0) ObjectDelete(t1);
  if(!ObjectCreate(t1,OBJ_LABEL,0,0,0))Print("error: cant create ",t1," ! 0   code #",GetLastError());
  if(!ObjectSet(t1,OBJPROP_XDISTANCE,4))Print("error: cant set xdistance ",t1," ! 0   code #",GetLastError());
  if(!ObjectSet(t1,OBJPROP_YDISTANCE,60))Print("error: cant set ydistance ",t1," ! 0   code #",GetLastError());
  if(!ObjectSet(t1,OBJPROP_WIDTH,1))Print("error: cant set width ",t1," ! 0   code #",GetLastError());
  ObjectSetText(t1, "OPEN BUY Profit : "+DoubleToStr(OpenOrderProfit(0),0), 11, "Arial Black", DodgerBlue);
  }
//----sell1
  if(CalculateCurrentOrder(1)==1){
  if(ObjectFind("grr1rgfl") >= 0)ObjectDelete("grr1rgfl");if(ObjectFind("grr1rgdgdffle") >= 0)ObjectDelete("grr1rgdgdffle");
  t1="grr1rjk32gfl";
  if(ObjectFind(t1) >= 0) ObjectDelete(t1);
  if(!ObjectCreate(t1,OBJ_LABEL,0,0,0))Print("error: cant create ",t1," ! 0   code #",GetLastError());
  if(!ObjectSet(t1,OBJPROP_XDISTANCE,235))Print("error: cant set xdistance ",t1," ! 0   code #",GetLastError());
  if(!ObjectSet(t1,OBJPROP_YDISTANCE,45))Print("error: cant set ydistance ",t1," ! 0   code #",GetLastError());  
  ObjectSetText(t1, "OPEN SELL @ : "+DoubleToStr(OpenOrderKurs(1) ,4), 11, "Arial Black", Red);
  t1="grr1rjk32gflefg";
  if(ObjectFind(t1) >= 0) ObjectDelete(t1);
  if(!ObjectCreate(t1,OBJ_LABEL,0,0,0))Print("error: cant create ",t1," ! 0   code #",GetLastError());
  if(!ObjectSet(t1,OBJPROP_XDISTANCE,235))Print("error: cant set xdistance ",t1," ! 0   code #",GetLastError());
  if(!ObjectSet(t1,OBJPROP_YDISTANCE,60))Print("error: cant set ydistance ",t1," ! 0   code #",GetLastError());  
  ObjectSetText(t1, "OPEN SELL Profit : "+DoubleToStr(OpenOrderProfit(1),0), 11, "Arial Black", Red);
  }
}
int err = GetLastError();if(err>0)Print("bei kommentare anzeigen Error  #",err);
}


double OpenOrderProfit(int nr)
{
for(int cnt=0; cnt <= OrdersTotal(); cnt++)
 {
   if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)==true)
   {  
   if(OrderSymbol()==Symbol()&& StringSubstr(OrderComment(),0,4) == StringSubstr(scriptname,0,4))
    {
    if(OrderType() == nr) 
    {    
     double profit=OrderProfit();     
     return(profit);
    }
   }
   }
 }
 return(0);
}

double OpenOrderKurs(int nr)
{
for(int cnt=0; cnt <= OrdersTotal(); cnt++)
 {
   if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES)==true)
   {  
   if(OrderSymbol()==Symbol()&& StringSubstr(OrderComment(),0,4) == StringSubstr(scriptname,0,4))
    {
    if(OrderType() == nr) 
    {    
     double kurs=OrderOpenPrice();     
     return(kurs);
    }
   }
   }
 }
 return(0);
}

//+-------------------------------------------------------------------+
//| Check for OrderGesamt                                             |
//+-------------------------------------------------------------------+
void OrdersGesamt(string symbol, int &offengesamt, int &closesgesamt, double &openordersprofitgesamt, double &closeordersprofitgesamt )
  {  
  offengesamt=0;
  openordersprofitgesamt=0; 
 //---- calculate open orders 
 if(OrdersTotal() > 0)
 { 
   for(int i=0;i<OrdersTotal();i++)
     {              
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false) break;
      if(OrderSymbol() == symbol && StringSubstr(OrderComment(),0,4) == StringSubstr(scriptname,0,4))
        {        
         openordersprofitgesamt += OrderProfit();                                                                 
        }
     }//for
  }
  //--------------------------------------------------------------------------- 
   closesgesamt=0;
   closeordersprofitgesamt=0;   
   //---- calculate close orders
   for(i=0; i<OrdersHistoryTotal(); i++)
     {     
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) continue;
      if(OrderSymbol() == symbol && StringSubstr(OrderComment(),0,4) == StringSubstr(scriptname,0,4))
        {
         closeordersprofitgesamt += OrderProfit();         
        }

     }//for 
    //Print("closeordersprofitgesamt ",closeordersprofitgesamt,"  orht ",OrdersHistoryTotal());
    Profit();
//---- Ende OrdersGesamt return 
   return;   
  }

void Profit()
{                  
//----Open
if(OrdersTotal() > 0) 
 {
  string t1="mk13";
  if(ObjectFind(t1) >= 0 ) ObjectDelete(t1);
  if(!ObjectCreate(t1,OBJ_LABEL,0,0,0))Print("error: cant create ",t1," ",scriptname,"   code #",GetLastError());
  if(!ObjectSet(t1,OBJPROP_XDISTANCE,4))Print("error: cant set xdistance ",t1," ",scriptname,"   code #",GetLastError());
  if(!ObjectSet(t1,OBJPROP_YDISTANCE,290))Print("error: cant set ydistance ",t1," ",scriptname,"   code #",GetLastError());
  if(!ObjectSet(t1,OBJPROP_WIDTH,1))Print("error: cant set width ",t1," ",scriptname,"   code #",GetLastError());
  ObjectSetText(t1, "Gesamt Profit: "+DoubleToStr(OpenOrdersProfitGesamt,0), 13, "Arial Black", Gold);
  //(Open_Orders_1_[0][2]+Open_Orders_2_[0][2]+Open_Orders_3_[0][2]+Open_Orders_4_[0][2])
 }
 else if(ObjectFind("mk13") >= 0 ) ObjectDelete("mk13");  
//----Close
if(OrdersHistoryTotal() > 0) 
 {
  t1="mk14";
  if(ObjectFind(t1) >= 0 ) ObjectDelete(t1);
  if(!ObjectCreate(t1,OBJ_LABEL,0,0,0))Print("error: cant create ",t1," ",scriptname,"   code #",GetLastError());
  if(!ObjectSet(t1,OBJPROP_XDISTANCE,4))Print("error: cant set xdistance ",t1," ",scriptname,"   code #",GetLastError());
  if(!ObjectSet(t1,OBJPROP_YDISTANCE,310))Print("error: cant set ydistance ",t1," ",scriptname,"   code #",GetLastError());
  if(!ObjectSet(t1,OBJPROP_WIDTH,1))Print("error: cant set width ",t1," ",scriptname,"   code #",GetLastError());
  ObjectSetText(t1, "Gesamt Profit Close Orders: "+DoubleToStr(CloseOrdersProfitGesamt,0), 13, "Arial Black", Gold);
 } 
 int err = GetLastError();if(err>0)Print("in profitanzeige Error  #",err);
return;
}